<?php
/*-------------------------------------------------------
 * @Module Name: LS Arduino
 * @Module URI: http://robocraft.ru
 * @Description: модуль получения данных от платы ардуино
 * @Version: 0.01
 * @Author: Vladimir (noonv)
 * @Author URI: http://robocraft.ru
 * @LiveStreet Version: 0.3.1
 * @License: RoboCraft.ru
 *----------------------------------------------------------------------------
 */


class ActionLsArduino extends Action {

	public function Init() {
		//$this->SetDefaultEvent('EventAdmin');
		
	}

	protected function RegisterEvent() {
		//$this->AddEvent('admin','EventAdmin');
		$this->AddEvent('action','EventAction');
		$this->AddEvent('actions','EventActions');
		$this->AddEvent('add','EventAdd');
	}
	
	//
	// админка - просмотр и удаление сообщений от Arduino
	//
	//protected function EventAdmin()
	protected function EventNotFound()
	{
		$oUserCurrent=$this->User_GetUserCurrent();
		$result = false;
		
		if($oUserCurrent && $oUserCurrent->isAdministrator())
		{
			if(getRequest('deleteLsArduino'))
			{
				$this->Security_ValidateSendForm();
				$result = $this->LsArduino_DeleteNote(getRequest('deleteLsArduino'));
				$this->Message_AddNotice($this->Lang_Get('lsarduino_dell_succes'),'LsArduino');
			}
		}
			$listArduinoNotes = $this->LsArduino_GetAllNotes();
			$this->Viewer_Assign('listArduinoNotes',$listArduinoNotes);

			$this->SetTemplateAction('admin'); 
			return $result;
		
		// else
		// {
			// $this->Message_AddErrorSingle($this->Lang_Get('not_access'),$this->Lang_Get('error'));
			// return Router::Action('error');
		// }
	}
	
	//
	// просмотр, добавление и удаление действий для Arduino
	//
	protected function EventAction()
	{
		$oUserCurrent=$this->User_GetUserCurrent();
		$result = false;
		
		if($oUserCurrent && $oUserCurrent->isAdministrator())
		{
			if(getRequest('deleteArduinoAction'))
			{
				$this->Security_ValidateSendForm();
				$result = $this->LsArduino_DeleteAction(getRequest('deleteArduinoAction'));
				$this->Message_AddNotice($this->Lang_Get('lsarduino_dell_succes'),'LsArduino');
			}
		}
			$listArduinoTodo = $this->LsArduino_GetAllTodo();
			$this->Viewer_Assign('listArduinoTodo',$listArduinoTodo);
			
			// получаем список типов заданий
			$listActions = $this->LsArduino_GetAllActions();
			$this->Viewer_Assign('listActions',$listActions);
			
			// получаем список состояний заданий
			$listActionStatus = $this->LsArduino_GetAllActionStatuses();
			$this->Viewer_Assign('listActionStatus',$listActionStatus);

			$this->SetTemplateAction('todo'); 
			return $result;
	}
	
	//
	// выгрузка заданий для Arduino в виде xml
	//
	protected function EventActions()
	{
		Router::SetIsShowStats(false);
		header('Content-Type: application/rss+xml; charset=utf-8');
		
		$result = false;
		$listArduinoTodo = $this->LsArduino_GetNewTodo();
		$this->Viewer_Assign('listArduinoTodo',$listArduinoTodo);
		
		$this->SetTemplateAction('xml'); 
		return $result;
	}
	
	//
	// добавление действия для Arduino
	//
	protected function EventAdd()
	{
		$oUserCurrent=$this->User_GetUserCurrent();
		$result = false;
		
		if($oUserCurrent)
		{
			if(isset($_REQUEST['submit_new_todo']))
			{
				$this->Security_ValidateSendForm();
				
				$todo_user_id=$oUserCurrent->getId();
				$todo_action = getRequest('todo_action');;
				$todo_text = getRequest('todo_text');;
				$todo_date=date("Y-m-d H:i:s");
				$todo_status=1;
				//
				// сначала проверим - есть ли уже аналогичное задание в БД, чтобы не плодить дубликаты
				//
				if($this->LsArduino_GetTodoByAction($todo_action, $todo_status))
				{
					$this->Message_AddError($this->Lang_Get('lsarduino_add_duplicate'),'LsArduino');
					return false;
				}
				//
				// сохраняем задание в БД
				//
				$result = $this->LsArduino_AddTodo($todo_user_id, $todo_action, $todo_text, $todo_date, $todo_status);
				$this->Message_AddNotice($this->Lang_Get('lsarduino_add_succes'),'LsArduino');
				return $result;
			}
			// получаем список типов заданий
			$listActions = $this->LsArduino_GetAllActions();
			$this->Viewer_Assign('listActions',$listActions);
		}
		else
		{
			$this->Message_AddErrorSingle($this->Lang_Get('not_access'),$this->Lang_Get('error'));
			return Router::Action('error');
		}
	}
}
