<?php
/*-------------------------------------------------------
 * @Module Name: LS Arduino
 * @Module URI: http://robocraft.ru
 * @Description: модуль получения данных от платы ардуино
 * @Version: 0.01
 * @Author: Vladimir (noonv)
 * @Author URI: http://robocraft.ru
 * @LiveStreet Version: 0.3.1
 * @License: RoboCraft.ru
 *----------------------------------------------------------------------------
 */

set_include_path(get_include_path().PATH_SEPARATOR.dirname(__FILE__));
require_once('mapper/LsArduino.mapper.class.php');

/**
 * Модуль получения данных от платы ардуино
 *
 */
class LsLsArduino extends Module {

	protected $oMapper;

	/**
	 * Инициализируем модуль
	 *
	 */
	public function Init()
	{
		$this->oMapper=new Mapper_LsArduino($this->Database_GetConnect());
		// ! после установки и начала работы с модулем можно закомментировать!
		$this->oMapper->CreateTables(); // < ---------- !!! 
		// удаляем старые сообщения
		$this->DeleteOldNotes();
		$this->DeleteOldTodo();
	}

	/**
	 * получаем последнее сообщение
	 *
	 * @return unknown
	 */
	public function GetLastNote()
	{
		return $this->oMapper->GetLastNote();
	}
	
	/**
	 * получаем все сообщения
	 *
	 * @return unknown
	 */
	public function GetAllNotes()
	{
		return $this->oMapper->GetAllNotes();
	}

	/**
	 * новое сообщение
	 *
	 * @return unknown
	 */
	public function AddNote($note_text, $note_data, $note_date, $note_user_id, $note_visible)
	{
		return $this->oMapper->AddNote($note_text, $note_data, $note_date, $note_user_id, $note_visible);
	}

	/**
	 * удаляем сообщение
	 *
	 * @return unknown
	 */
	public function DeleteNote($array)
	{
		return $this->oMapper->DeleteNote($array);
	}
	
	/**
	 * удаляем задание
	 *
	 * @return unknown
	 */
	public function DeleteAction($array)
	{
		return $this->oMapper->DeleteAction($array);
	}
	
	/**
	 * получаем все задания
	 *
	 * @return unknown
	 */
	public function GetAllTodo()
	{
		return $this->oMapper->GetAllTodo();
	}
	
	/**
	 * получаем только новые задания - статус 1
	 *
	 * @return unknown
	 */
	public function GetNewTodo()
	{
		return $this->oMapper->GetNewTodo();
	}
	
	/**
	 * получаем все статусы заданий
	 *
	 * @return unknown
	 */
	public function GetAllActionStatuses()
	{
		return $this->oMapper->GetAllActionStatuses();
	}
	
	/**
	 * получаем все типы заданий
	 *
	 * @return unknown
	 */
	public function GetAllActions()
	{
		return $this->oMapper->GetAllActions();
	}
	
	/**
	 * новое задание
	 *
	 * @return unknown
	 */
	public function AddTodo($todo_user_id, $todo_action, $todo_text, $todo_date, $todo_status)
	{
		return $this->oMapper->AddTodo($todo_user_id, $todo_action, $todo_text, $todo_date, $todo_status);
	}
	
	/**
	 * получить задания по типу задачи и статусу        - нужно чтобы проверить есть ли уже аналогичное новое задание
	 *
	 * @return unknown
	 */
	public function GetTodoByAction($todo_action, $todo_status)
	{
		return $this->oMapper->GetTodoByAction($todo_action, $todo_status);
	}
	
	/**
	 * изменить статус задания
	 *
	 * @return unknown
	 */
	public function SetTodoStatus($todo_id, $todo_status)
	{
		return $this->oMapper->SetTodoStatus($todo_id, $todo_status);
	}
	
	/**
	 * удаляем старые сообщения
	 *
	 * @return unknown
	 */
	public function DeleteOldNotes()
	{
		return $this->oMapper->DeleteOldNotes();
	}
	
	/**
	 * удаляем старые задания
	 *
	 * @return unknown
	 */
	public function DeleteOldTodo()
	{
		return $this->oMapper->DeleteOldTodo();
	}
}
